C
C     COLRED TEST DRIVER TEXT
C
C     Version dd February 24, 1995.
C     Revised May 21, 1996.
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER NIN, NOUT
      PARAMETER (NIN = 5, NOUT = 6)
      DOUBLE PRECISION ONE
      PARAMETER (ONE = 1.0D0)
C
      INTEGER DPMAX, MPMAX, NPMAX
      PARAMETER (DPMAX = 6, MPMAX = 8, NPMAX = 10)
      INTEGER MAMAX, NAMAX, LIWORK, LRWORK, DRMAX
      PARAMETER (MAMAX = (NPMAX * DPMAX + 1) * MPMAX, 
     *           NAMAX = MAMAX + NPMAX,
     *           LIWORK = 2 * MAMAX + 2 * NPMAX + 1,
     *           LRWORK = (2*MAMAX + NPMAX*DPMAX + 5) * NAMAX +
     *                    MAMAX + (2*MPMAX + 1) * NPMAX,
     *            DRMAX = (NPMAX+1)*DPMAX + 1)
      INTEGER LDP1, LDP2, LDR1, LDR2, LDU1, LDU2
      PARAMETER (LDP1 = MPMAX, LDP2 = NPMAX, LDR1 = MPMAX,
     *           LDR2 = NPMAX, LDU1 = NPMAX, LDU2 = NPMAX)
C     .. Local Scalars ..
      INTEGER MP, NP, DP, DR, DU, I, J, K, L, NUM, IERR
      DOUBLE PRECISION TOL
C     .. Local Arrays ..
      INTEGER IWORK(LIWORK)
      DOUBLE PRECISION P(LDP1,LDP2,DPMAX+1), R(LDR1,LDR2,DRMAX),
     *                 U(LDU1,LDU2,NPMAX*DPMAX+1), RWORK(LRWORK)
      LOGICAL ZERCOL(NPMAX)
C     .. External Subroutines/Functions ..
      EXTERNAL COLRED, MULTPM, PRMAPO
C
C     .. Executable Statements ..
C
C     Read NUM, that is the number of testcases to be run.
C
      READ(NIN, FMT = *) NUM
C
      DO 30 L = 1, NUM
C
         WRITE(NOUT, FMT = 99999) L
         READ(NIN, FMT = '()')
C
C        Read MP, NP, DP, TOL and next P(k), k = 0,....,DP row after row.
C
         READ(NIN, FMT = *) MP, NP, DP, TOL
C
         DO 20 K = 1, DP + 1
            READ(NIN, FMT = '()')
            DO 10 I = 1, MP
               READ(NIN, FMT = *) (P(I,J,K), J = 1, NP)
 10         CONTINUE
 20      CONTINUE
C
         WRITE(NOUT, FMT = 99998) DP, MP, NP, TOL
         CALL PRMAPO(MP, NP, DP, 5, NOUT, P, LDP1, LDP2, 'P', IERR)
C
         CALL COLRED(MP, NP, DP, P, LDP1, LDP2, DR, DU, R, LDR1, LDR2,
     *               U, LDU1, LDU2, ZERCOL, IWORK, RWORK, TOL, IERR)
C
         IF (IERR .EQ. 0) THEN
            WRITE (NOUT, FMT = 99997)
            CALL PRMAPO(NP, NP, DU, 5, NOUT, U, LDU1, LDU2, 'U', IERR)
C
            WRITE (NOUT, FMT = 99996)
            CALL PRMAPO(MP, NP, DR, 5, NOUT, R, LDR1, LDR2, 'R', IERR)
            WRITE (NOUT, FMT = 99995) (ZERCOL(J), J = 1, NP)
C
            CALL MULTPM(-ONE, MP, NP, NP, DP, DU, DR, P, LDP1, LDP2,
     *                  U, LDU1, LDU2, R, LDR1, LDR2, RWORK, IERR)
            IF (DR .GE. 0) THEN
               WRITE (NOUT, FMT = 99994)
               CALL PRMAPO(MP, NP, DR, 5, NOUT, R, LDR1, LDR2,
     *                     '(PU - R)', IERR)
            ELSE
               WRITE (NOUT, FMT = 99993)
            END IF
         ELSE
            WRITE (NOUT, FMT = 99992) IERR
         END IF
 30   CONTINUE
      STOP
C
99999 FORMAT (//' COLRED TEST DRIVER RESULTS, EXAMPLE(', I2, ')', /1X)
99998 FORMAT (' The input polynomial matrix:', //,
     *        ' P(s) = P(0) + P(1) * s + . . . + P(dp-1) * s**(dp-1)',
     *        '  + P(dp) * s**dp', //, ' with degree DP =', I2,
     *        ' and size MP =', I2, ', NP =', I2, '.', //,
     *        ' The tolerance is:', D10.3, /1X)
99997 FORMAT (' The unimodular polynomial matrix U(s):')
99996 FORMAT (' The column reduced polynomial matrix R(s):')
99995 FORMAT (' ZERCOL(j), j = 1, NP:', 10(L2))
99994 FORMAT (' The residual matrix P(s) * U(s) - R(s):')
99993 FORMAT (' PU - R is the ZERO polynomial matrix.')
99992 FORMAT (' COLRED has failed: IERR =', I2)
      END

