      SUBROUTINE DLAVEC( N, CONST, X, INCX )
C
C  -- LAPACK like auxiliary routine
C     August 31, 1994
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION   CONST
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  Purpose
C  =======
C
C  DLAVEC performs the operation
C
C     x = const*e,   e' = ( 1  1 ... 1 ).
C
C  NB. This routine is derived from the Nag Fortran 77 O( n ) basic
C      linear algebra routine F06FBF.
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      INTEGER            IX
C     ..
C
C     .. Executable Statements ..
      IF( N.GT.0 ) THEN
         IF( CONST.NE.ZERO ) THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = CONST
   10       CONTINUE
         ELSE
            DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ZERO
   20       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of DLAVEC
C
      END
